/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#define	LIBTEKLTI_EXPORT	(0)
#define	TEKFILE_INTERNAL	(0)


#ifndef	_cplusplus
#define	_cplusplus
#endif	/* _cplusplus */
#include "teklti.h"

#ifdef	NULL
#undef	NULL
#endif	/* NULL */

#define	NULL	0


TEKERR TekFileCreate(TekFileType FileType, TekFile ** RetVal, uchar_t * FileName)
{
	TekFileBinary * NewValBinary;

#ifndef	NO_SIZE_T_CHECKS
	if ( RetVal == NULL )
		return TEKERR_POINTER;
#endif	/* NO_SIZE_T_CHECKS */

	switch ( FileType )
	{
		case TekFileType_Binary:
			/* Make a new instance. */
			NewValBinary = new TekFileBinary;
			/* Check to see if we have to call put_Filename. */
			if ( FileName != NULL )
				NewValBinary->put_Filename(FileName);

			/* Set TekFile. */
			*RetVal = (TekFile *)NewValBinary;
			/* Return to caller. */
			return TEKERR_OK;
		case TekFileType_BinaryPipe:
			/* Make a new instance. */
			NewValBinary = new TekFileBinary;
			/* Change flag to Binary_Pipe. */
			NewValBinary->ConvertToPipe();

			/* Set the RetVal. */
			*RetVal = (TekFile *)NewValBinary;
			/* Return to caller. */
			return TEKERR_OK;
		case TekFileType_ASCII:
		case TekFileType_ConfigASCII:
		case TekFileType_UNICODE:
		case TekFileType_ConfigUNICODE:
		case TekFileType_ASCIIPipe:
		case TekFileType_UnicodePipe:
		case TekFileType_BZIP2:
		default:
			return TEKERR_UNAVAILABLE;
	}
}


MKTEKUUID(UTekFile, "af7d74d2-db02-11d9-9782-000bdbc434d9")
MKTEKDEBUGSTRING(DBTekFile, "TekFile")

/* TEKSTD_IMPLEMENT_INTERFACE(UTekFile) */

/**
Instantizer.
*/
TekFile::TekFile()
{
	;
}

/**
Destructor.
*/
TekFile::~TekFile()
{
	;
}



#if	NULL != 0
//TEKSTD_SOURCE_FUNC(TekFile);
//TEKSTD_SOURCE_FUNC_CALLFUNC(TekFile);


/**
    \fn TekFile::get_FILE(FILE ** FileDescriptor)
    
    Obtains the handle used to access the open file.
 */
TEKERR TekFile::get_FILE(FILE ** FileDescriptor)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFile::get_Filename(uchar_t ** Name)
    
    Obtains the filename in the form of a uchar.
 */
TEKERR TekFile::get_Filename(uchar_t ** Name)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFile::put_FILE(FILE * FileDescriptor)
    
    Sets the handle used to access a file.\n
    \n
    WARNING!!!!!  DO NOT USE THE FILE DESCRIPTOR YOU PASS IN \n
    TO THIS FUNCTION UNLESS YOU HAVE RE-RETRIEVED IT USING \n
    TekFile::get_FILE()!  Utilizing the descriptor in a direct fashion after a \n
    successful call to put_FILE() will result in undefined results!!!!!
 */
TEKERR TekFile::put_FILE(FILE * FileDescriptor)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFile::put_Filename(uchar_t * Name)
    
    Sets the filename to access.
 */
TEKERR TekFile::put_Filename(uchar_t * Name)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::get_Type(TekFileType * FileTypePointer)
    
    Gets the file type.
 */
TEKERR TekFile::get_Type(TekFileType * FileTypePointer)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Close()
    
    Closes the file.
 */
TEKERR TekFile::Close()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::get_Mode(TekFileMode * ModeID)
    
    Retrieves the mode currently set.
 */
TEKERR TekFile::get_Mode(TekFileMode * ModeID)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Flush()
    
    Flushes the buffer.
 */
TEKERR TekFile::Flush()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Open()
    
    Open the file.
 */
TEKERR TekFile::Open()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Open64()
    
    Open the file using 64 bit semantics.
 */
TEKERR TekFile::Open64()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::put_Mode(TekFileMode ModeID)
    
    Sets the mode used to open the file.
 */
TEKERR TekFile::put_Mode(TekFileMode ModeID)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Read64(void * Buffer, uint64_t BytesToRead, uint64_t * BytesRead)
    
    Read from the file using 64 bit semantics.
 */
TEKERR TekFile::Read64(void * Buffer, uint64_t BytesToRead, uint64_t * BytesRead)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Read(void * Buffer, unsigned long BytesToRead, unsigned long * BytesRead)
    
    Read from the file.
 */
TEKERR TekFile::Read(void * Buffer, unsigned long BytesToRead, unsigned long * BytesRead)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Seek64(TekFileSeek SeekWhere, int64_t NewLocation)
    
    Seek to another position of the file using 64 bit semantics.
 */
TEKERR TekFile::Seek64(TekFileSeek SeekWhere, int64_t NewLocation)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Seek(TekFileSeek SeekWhere, signed long NewLocation)
    
    Seek to another position of the file.
 */
TEKERR TekFile::Seek(TekFileSeek SeekWhere, signed long NewLocation)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Write64(void * Buffer, uint64_t BytesToWrite, uint64_t * BytesWrote)
    
    Write to the file using 64 bit semantics.
 */
TEKERR TekFile::Write64(void * Buffer, uint64_t BytesToWrite, uint64_t * BytesWrote)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::Write(void * Buffer, unsigned long BytesToWrite, unsigned long * BytesWrote)
    
    Write to the file.
 */
TEKERR TekFile::Write(void * Buffer, unsigned long BytesToWrite, unsigned long * BytesWrote)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::get_Location(unsigned long * Location)

    Retrieves the location.
 */

TEKERR TekFile::get_Location(unsigned long * Location)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFile::get_Location64(uint64_t * Location)

    Retrieves the location and stores it in a 64-bit variable.
 */

TEKERR TekFile::get_Location64(uint64_t * Location)
{
	return TEKERR_NOTIMPL;
}

#endif	/* NULL != 0 */

